
Foreman - Feature #32286

Tracker # 29939 (Closed): Improve setting definition DSL and move setting registry to memory

Create a new setting definition DSL

04/10/2021 10:21 PM - Ondřej Ezr

Status: Closed   

Priority: Normal   

Assignee: Ondřej Ezr   

Category: Settings   

Target version:    

Difficulty:  Fixed in Releases: 3.0.0

Triaged: No Found in Releases:  

Bugzilla link:  Red Hat JIRA:  

Pull request: https://github.com/theforeman/foreman/p

ull/8437,

https://github.com/theforeman/foreman/p

ull/8624

  

Description

We should drop setting STI and introduce a new way of defining settings.

For plugins and for core alike.

I'd imagine it similar to permissions, just simplier hopefully.

Related issues:

Related to Foreman - Bug #33706: SettingRegistry fails on older categories if... Closed

Related to Foreman - Bug #33740: Setting DSL does not use the explicit initia... Closed

Blocks Foreman - Refactor #32403: Add custom validations to new setting DSL Closed

Blocks Foreman - Refactor #32408: Use new DSL to define settings Closed

Associated revisions

Revision 074be461 - 06/29/2021 07:57 AM - Ondřej Ezr

Fixes #32286 - new settings definition DSL

Introduces a new DSL to define settings, so we don't need to define

STI classes for every setting category and we have more control over

settings from the plugins.

Revision efa0e618 - 09/24/2021 11:25 AM - Ondřej Ezr

Refs #32286 - setting DSL switch preparation

Removes some unused methods and tests.

This also add collections to the old collection registry to work before we hold them in registry only.

Revision aecd6902 - 09/24/2021 11:25 AM - Ondřej Ezr

Refs #32286 - load definition even in migrations

Loads definitions on every start and makes sure the definitions are always loaded.

This makes it possible to work with settings in migrations.

Only values needs the database, so this is safe to do without any check.

History

#1 - 04/10/2021 11:19 PM - The Foreman Bot

- Status changed from New to Ready For Testing

- Pull request https://github.com/theforeman/foreman/pull/8437 added

#2 - 04/24/2021 08:28 PM - Ondřej Ezr

- Blocks Refactor #32403: Add custom validations to new setting DSL added
#3 - 04/24/2021 08:34 PM - Ondřej Ezr

- Blocks Refactor #32408: Use new DSL to define settings added

#4 - 06/28/2021 11:44 AM - The Foreman Bot

- Pull request https://github.com/theforeman/foreman/pull/8624 added

#5 - 06/28/2021 11:58 AM - The Foreman Bot

- Pull request https://github.com/theforeman/foreman/pull/8470 added

#6 - 06/28/2021 12:28 PM - The Foreman Bot

- Pull request https://github.com/theforeman/foreman/pull/8625 added

#7 - 06/29/2021 07:58 AM - The Foreman Bot

- Fixed in Releases 3.0.0 added

#8 - 06/29/2021 08:08 AM - Ondřej Ezr

- Status changed from Ready For Testing to Closed

Applied in changeset foreman|074be4618215e0110b652f1cbc086e9d758e8a7e.

#9 - 09/22/2021 10:06 AM - Ondřej Ezr

- Pull request deleted (https://github.com/theforeman/foreman/pull/8470, https://github.com/theforeman/foreman/pull/8625)

#10 - 10/18/2021 12:57 PM - Ondřej Ezr

- Related to Bug #33706: SettingRegistry fails on older categories if setting table is not ready added

#11 - 10/20/2021 10:45 AM - Ondřej Ezr

- Related to Bug #33740: Setting DSL does not use the explicit initial values added
